const produtosDisponiveisRepository = require("../infra/repository/produtos.disponiveis.repository");
const produtosDiponiveis = new produtosDisponiveisRepository();

const jwt = require("jsonwebtoken");

class produtosDiponiveisController {


  /**
   * Vincula um produto a um usuario
   * @returns mensagem referente ao resultado obtido
   */
  vincularProdutoUser() {
    return function (req, res) {
      const data = req.body;

      produtosDiponiveis
        .vincularProdutoUser(data)
        .then((response) => {
          if (response.error)
            return res.status(response.code).send({ error: response.error });
          else return res.status(200).json(response);
        })
        .catch((error) => {
          console.log(error);
          
          return res
            .status(400)
            .send({ error: `Não foi possível vincular!` });
        });
    };
  }

  /**
   * Lista todos os produtosDiponiveis
   * @returns mensagem referente ao resultado obtido
   */
  listProdutoDisponiveisByUser() {
    return function (req, res) {
      const id_user = req.query.id_user

      produtosDiponiveis
        .listProdutoDisponiveisByUser(id_user)
        .then((response) => {
          if (response.error)
            res.status(response.code).send({ error: response.error });
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }

    /**
   * Lista todos os produtosDiponiveis
   * @returns mensagem referente ao resultado obtido
   */
    listProdutoComVinculos() {
      return function (req, res) {
        const id_user = req.query.id_user
  
        produtosDiponiveis
          .listProdutoComVinculos(id_user)
          .then((response) => {
            if (response.error)
              res.status(response.code).send({ error: response.error });
            else return res.status(200).send(response);
          })
          .catch((error) => {
            throw new Error(error);
          });
      };
    }
  /**
   * Desvincula um produto de um usuario
   * @returns mensagem referente ao resultado obtido
   */
  desvincularProdutoDeUsuario() {
    return function (req, res) {
      const  id_user  = req.query.id_user;
      const  id_produto  = req.query.id_produto;


      produtosDiponiveis
        .desvincularProdutoDeUsuario(id_user, id_produto)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }
  /**
   * Atualiza os dados de um vendedor
   * @returns mensagem referente ao resultado obtido
   */
  update() {
    return function (req, res) {
      const data = req.body;

      produtosDiponiveis
        .update(data)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }


    listQtdeTotalprodutosDiponiveisContrato() {
      return function (req, res) {
        const dataInicio = req.query.dataInicio;
        const dataFim = req.query.dataFim;
  
        produtosDiponiveis
          .listQtdeTotalprodutosDiponiveisContrato(dataInicio, dataFim)
          .then((response) => {
            if (response.error)
              res.status(response.code).send({ error: response.error });
            else return res.status(200).send(response);
          })
          .catch((error) => {
            throw new Error(error);
          });
      };
    }


}

module.exports = produtosDiponiveisController;

